=== modified file 'NEWS'
--- NEWS	2007-08-22 19:47:46 +0000
+++ NEWS	2007-08-23 10:17:40 +0000
@@ -13,6 +13,8 @@
 
   * Add remove and delete menu item in Olive. (#127392, Mateusz Korniak)
   
+  * Added "update" menu item in Olive. (Mateusz Korniak)
+  
   * New Olive application icon. (Simon Pascal Klein)
 
  UI

=== modified file 'TODO'
--- TODO	2007-07-07 22:02:45 +0000
+++ TODO	2007-08-23 10:17:40 +0000
@@ -4,6 +4,7 @@
 - List unknown files in commit dialog
 - Allow merging revisions from missing dialog
 - It should be possible to add unknown files from the commit dialog.
+  Deleting selected unknown files should be also possible ?
 - Eliminate radiobuttons in push but rather show the default location and 
   allow the user to change it
 - Remove the status window as it's pointless since the status is already shown
@@ -19,3 +20,9 @@
   should keep a read lock open and only release this when the url is changed.
   It should also allow the creator of the window to supply an already opened
   branch, and a revision id.
+- olive-gtk: Allow diffing with external programs (kdiff3, meld? )
+  Allowing to revert parts of modified using external tools
+- olive-gtk: History of recently opened branches/checkouts
+- olive-gtk: Info about current director in status line (is it branch/checkout , parent branch/ checkout root)
+- olive-gtk: Info about dirs state (including summary of state files and dirs inside directory)
+- olive-gtk: mark modified, deleted files in dir with colors

=== modified file '__init__.py'
--- __init__.py	2007-08-10 14:16:09 +0000
+++ __init__.py	2007-08-23 10:17:40 +0000
@@ -59,7 +59,7 @@
         from bzrlib.errors import BzrError
         warning('Installed bzr version %s is too old to be used with bzr-gtk'
                 ' %s.' % (bzrlib.__version__, __version__))
-        raise BzrError('Version mismatch: %r' % version_info)
+        raise BzrError('Version mismatch: %r' % (version_info,) )
     else:
         warning('bzr-gtk is not up to date with installed bzr version %s.'
                 ' \nThere should be a newer version available, e.g. %i.%i.' 

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2007-08-22 19:30:48 +0000
+++ olive/__init__.py	2007-08-23 10:17:40 +0000
@@ -108,6 +108,7 @@
         self.menuitem_branch_checkout = self.toplevel.get_widget('menuitem_branch_checkout')
         self.menuitem_branch_pull = self.toplevel.get_widget('menuitem_branch_pull')
         self.menuitem_branch_push = self.toplevel.get_widget('menuitem_branch_push')
+        self.menuitem_branch_update = self.toplevel.get_widget('menuitem_branch_update')
         self.menuitem_branch_revert = self.toplevel.get_widget('menuitem_branch_revert')
         self.menuitem_branch_merge = self.toplevel.get_widget('menuitem_branch_merge')
         self.menuitem_branch_commit = self.toplevel.get_widget('menuitem_branch_commit')
@@ -125,6 +126,7 @@
         self.toolbutton_commit = self.toplevel.get_widget('toolbutton_commit')
         self.toolbutton_pull = self.toplevel.get_widget('toolbutton_pull')
         self.toolbutton_push = self.toplevel.get_widget('toolbutton_push')
+        self.toolbutton_update = self.toplevel.get_widget('toolbutton_update')
         # Get the drive selector
         self.combobox_drive = gtk.combo_box_new_text()
         self.combobox_drive.connect("changed", self._refresh_drives)
@@ -165,6 +167,7 @@
                 "on_menuitem_branch_commit_activate": self.on_menuitem_branch_commit_activate,
                 "on_menuitem_branch_push_activate": self.on_menuitem_branch_push_activate,
                 "on_menuitem_branch_pull_activate": self.on_menuitem_branch_pull_activate,
+                "on_menuitem_branch_update_activate": self.on_menuitem_branch_update_activate,                
                 "on_menuitem_branch_tags_activate": self.on_menuitem_branch_tags_activate,
                 "on_menuitem_branch_status_activate": self.on_menuitem_branch_status_activate,
                 "on_menuitem_branch_missing_revisions_activate": self.on_menuitem_branch_missing_revisions_activate,
@@ -179,6 +182,7 @@
                 "on_toolbutton_commit_clicked": self.on_menuitem_branch_commit_activate,
                 "on_toolbutton_pull_clicked": self.on_menuitem_branch_pull_activate,
                 "on_toolbutton_push_clicked": self.on_menuitem_branch_push_activate,
+                "on_toolbutton_update_clicked": self.on_menuitem_branch_update_activate,
                 "on_treeview_right_button_press_event": self.on_treeview_right_button_press_event,
                 "on_treeview_right_row_activated": self.on_treeview_right_row_activated,
                 "on_treeview_left_button_press_event": self.on_treeview_left_button_press_event,
@@ -563,6 +567,17 @@
         ret = branch_to.pull(branch_from)
         
         info_dialog(_('Pull successful'), _('%d revision(s) pulled.') % ret)
+        
+    @show_bzr_error
+    def on_menuitem_branch_update_activate(self, widget):
+        """ Brranch/checkout update menu handler. """
+        
+        ret = self.wt.update()
+        conflicts = self.wt.conflicts()
+        if conflicts:
+            info_dialog(_('Update successful but conflicts generated'), _('Number of conflicts generated: %d.') % (len(conflicts),) )
+        else:
+            info_dialog(_('Update successful'), _('No conflicts generated.') )
     
     def on_menuitem_branch_push_activate(self, widget):
         """ Branch/Push... menu handler. """
@@ -1060,6 +1075,7 @@
             self.menuitem_branch_checkout.set_sensitive(self.notbranch)
             self.menuitem_branch_pull.set_sensitive(not self.notbranch)
             self.menuitem_branch_push.set_sensitive(not self.notbranch)
+            self.menuitem_branch_update.set_sensitive(not self.notbranch)
             self.menuitem_branch_revert.set_sensitive(not self.notbranch)
             self.menuitem_branch_merge.set_sensitive(not self.notbranch)
             self.menuitem_branch_commit.set_sensitive(not self.notbranch)
@@ -1081,6 +1097,7 @@
             self.toolbutton_commit.set_sensitive(not self.notbranch)
             self.toolbutton_pull.set_sensitive(not self.notbranch)
             self.toolbutton_push.set_sensitive(not self.notbranch)
+            self.toolbutton_update.set_sensitive(not self.notbranch)
         else:
             # We're remote
             self.menuitem_branch_init.set_sensitive(False)
@@ -1088,6 +1105,7 @@
             self.menuitem_branch_checkout.set_sensitive(True)
             self.menuitem_branch_pull.set_sensitive(False)
             self.menuitem_branch_push.set_sensitive(False)
+            self.menuitem_branch_update.set_sensitive(False)
             self.menuitem_branch_revert.set_sensitive(False)
             self.menuitem_branch_merge.set_sensitive(False)
             self.menuitem_branch_commit.set_sensitive(False)
@@ -1109,6 +1127,7 @@
             self.toolbutton_commit.set_sensitive(False)
             self.toolbutton_pull.set_sensitive(False)
             self.toolbutton_push.set_sensitive(False)
+            self.toolbutton_update.set_sensitive(False)
     
     def refresh_left(self):
         """ Refresh the bookmark list. """

